/*
 * Copyright (c) 2015-2016, Sumio Morioka
 * All rights reserved.
 *
 * This source code was originally written by Dr.Sumio Morioka for use in the 2015-2016 issues of 
 * "the Interface magazine", published by CQ publishing Co.Ltd in Japan (http://www.cqpub.co.jp).
 * The author has no responsibility on any results caused by using this code.
 *
 * - Author: Dr.Sumio Morioka (http://www002.upp.so-net.ne.jp/morioka, FB:Sumio Morioka)
 *
 *
 * IMPORTANT NOTICE:
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of the copyright holder nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _WEBSOCKET_FUNC_H
#define _WEBSOCKET_FUNC_H

#include "websocket_flags.h"

//////////////////////////////////////////////////////////////////////////// >>
// ADD YOUR ORIGINAL CODE HERE
// BODY of global variables
volatile int	pano_total_window_g	= 0;		// total # of window
volatile int	pano_disp_window_g	= 0;		// which window is currently displayed
volatile int	pano_window_width_g	= 0;		// width of window (height == PANO_SEG_H)
volatile char	wsocket_push_button_g	= 0;

volatile int	pano_total_segments_g;
//////////////////////////////////////////////////////////////////////////// <<

static int wsocket_callback_dumb_increment(struct libwebsocket_context *cntxt,
                                   struct libwebsocket *wsi,
                                   enum libwebsocket_callback_reasons reason,
                                   void *user,
                                   void *inp,
                                   size_t len)	// (main callback func)
{
//////////////////////////////////////////////////////////////////////////// >>
// ADD YOUR ORIGINAL CODE HERE
	switch (reason)	{
	case LWS_CALLBACK_ESTABLISHED:
		pano_disp_window_g		= 0;
		wsocket_push_button_g	= 0;
		fprintf(stderr, "websocket: connection established\n");
		break;

	case LWS_CALLBACK_RECEIVE:
		if (*((char	*)inp) != '!') {	// NOT KEEP	ALIVE MARK
//			fprintf(stderr,	"received data (%d): %s\n",	(int)len, (char	*)inp);

			switch (*((char *)inp)) {
			case 'c':	// reset
				pano_disp_window_g	= 0;
				fprintf(stderr, "\tdisp pos %d\n", pano_disp_window_g);
				break;
			case 'r':	// right
				if (pano_disp_window_g >= pano_total_window_g - 1)
					pano_disp_window_g	= 0;
				else
					pano_disp_window_g++;
				fprintf(stderr, "\tdisp pos %d\n", pano_disp_window_g);
				break;
			case 'l':	// left
				if (pano_disp_window_g <= 0)
					pano_disp_window_g	= pano_total_window_g - 1;
				else
					pano_disp_window_g--;
				fprintf(stderr, "\tdisp pos %d\n", pano_disp_window_g);
				break;
			case 'u':	// up
				wsocket_push_button_g	= 'u';
				break;
			case 'd':	// down
				wsocket_push_button_g	= 'd';
				break;
			default:
				break;
			}
		}

		// send	response TO AVOID TIMEOUT
		{
			unsigned char	buf	= '!';
			libwebsocket_write(wsi, &buf, 1, LWS_WRITE_TEXT);
		}
		break;

	case LWS_CALLBACK_CLOSED:
		fprintf(stderr, "websocket: connection closed\n");
		break;

	default:
		break;
	}

	return 0;
//////////////////////////////////////////////////////////////////////////// <<
}

#endif // _WEBSOCKET_FUNC_H

// end of file
